#ifndef BUILDINGSFORM_TEMPLATE_H
#define BUILDINGSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_BuildingsForm_template
{
public:
    QGridLayout *gridLayout;
    QPushButton *addBuildingPushButton;
    QPushButton *removeBuildingPushButton;
    QPushButton *closePushButton;
    QPushButton *sortBuildingsPushButton;
    QPushButton *modifyBuildingPushButton;
    Q3ListBox *buildingsListBox;
    Q3TextEdit *currentBuildingTextEdit;

    void setupUi(QDialog *BuildingsForm_template)
    {
        if (BuildingsForm_template->objectName().isEmpty())
            BuildingsForm_template->setObjectName(QString::fromUtf8("BuildingsForm_template"));
        BuildingsForm_template->resize(533, 505);
        gridLayout = new QGridLayout(BuildingsForm_template);
        gridLayout->setSpacing(6);
        gridLayout->setMargin(11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        addBuildingPushButton = new QPushButton(BuildingsForm_template);
        addBuildingPushButton->setObjectName(QString::fromUtf8("addBuildingPushButton"));

        gridLayout->addWidget(addBuildingPushButton, 2, 0, 1, 1);

        removeBuildingPushButton = new QPushButton(BuildingsForm_template);
        removeBuildingPushButton->setObjectName(QString::fromUtf8("removeBuildingPushButton"));

        gridLayout->addWidget(removeBuildingPushButton, 2, 1, 1, 1);

        closePushButton = new QPushButton(BuildingsForm_template);
        closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

        gridLayout->addWidget(closePushButton, 4, 0, 1, 2);

        sortBuildingsPushButton = new QPushButton(BuildingsForm_template);
        sortBuildingsPushButton->setObjectName(QString::fromUtf8("sortBuildingsPushButton"));

        gridLayout->addWidget(sortBuildingsPushButton, 3, 1, 1, 1);

        modifyBuildingPushButton = new QPushButton(BuildingsForm_template);
        modifyBuildingPushButton->setObjectName(QString::fromUtf8("modifyBuildingPushButton"));

        gridLayout->addWidget(modifyBuildingPushButton, 3, 0, 1, 1);

        buildingsListBox = new Q3ListBox(BuildingsForm_template);
        buildingsListBox->setObjectName(QString::fromUtf8("buildingsListBox"));

        gridLayout->addWidget(buildingsListBox, 1, 0, 1, 1);

        currentBuildingTextEdit = new Q3TextEdit(BuildingsForm_template);
        currentBuildingTextEdit->setObjectName(QString::fromUtf8("currentBuildingTextEdit"));
        currentBuildingTextEdit->setReadOnly(true);

        gridLayout->addWidget(currentBuildingTextEdit, 1, 1, 1, 1);

        QWidget::setTabOrder(buildingsListBox, addBuildingPushButton);
        QWidget::setTabOrder(addBuildingPushButton, removeBuildingPushButton);
        QWidget::setTabOrder(removeBuildingPushButton, modifyBuildingPushButton);
        QWidget::setTabOrder(modifyBuildingPushButton, sortBuildingsPushButton);
        QWidget::setTabOrder(sortBuildingsPushButton, closePushButton);
        QWidget::setTabOrder(closePushButton, currentBuildingTextEdit);

        retranslateUi(BuildingsForm_template);
        QObject::connect(addBuildingPushButton, SIGNAL(clicked()), BuildingsForm_template, SLOT(addBuilding()));
        QObject::connect(removeBuildingPushButton, SIGNAL(clicked()), BuildingsForm_template, SLOT(removeBuilding()));
        QObject::connect(buildingsListBox, SIGNAL(highlighted(int)), BuildingsForm_template, SLOT(buildingChanged(int)));
        QObject::connect(closePushButton, SIGNAL(clicked()), BuildingsForm_template, SLOT(close()));
        QObject::connect(modifyBuildingPushButton, SIGNAL(clicked()), BuildingsForm_template, SLOT(modifyBuilding()));
        QObject::connect(sortBuildingsPushButton, SIGNAL(clicked()), BuildingsForm_template, SLOT(sortBuildings()));
        QObject::connect(buildingsListBox, SIGNAL(selected(QString)), BuildingsForm_template, SLOT(modifyBuilding()));

        QMetaObject::connectSlotsByName(BuildingsForm_template);
    } // setupUi

    void retranslateUi(QDialog *BuildingsForm_template)
    {
        BuildingsForm_template->setWindowTitle(QApplication::translate("BuildingsForm_template", "Buildings", 0, QApplication::UnicodeUTF8));
        addBuildingPushButton->setText(QApplication::translate("BuildingsForm_template", "Add building", 0, QApplication::UnicodeUTF8));
        removeBuildingPushButton->setText(QApplication::translate("BuildingsForm_template", "Remove current", 0, QApplication::UnicodeUTF8));
        closePushButton->setText(QApplication::translate("BuildingsForm_template", "Close", 0, QApplication::UnicodeUTF8));
        sortBuildingsPushButton->setText(QApplication::translate("BuildingsForm_template", "Sort by name", 0, QApplication::UnicodeUTF8));
        modifyBuildingPushButton->setText(QApplication::translate("BuildingsForm_template", "Modify current", 0, QApplication::UnicodeUTF8));
        buildingsListBox->clear();
        buildingsListBox->insertItem(QApplication::translate("BuildingsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        Q_UNUSED(BuildingsForm_template);
    } // retranslateUi

};

namespace Ui {
    class BuildingsForm_template: public Ui_BuildingsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class BuildingsForm_template : public QDialog, public Ui::BuildingsForm_template
{
    Q_OBJECT

public:
    BuildingsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~BuildingsForm_template();

public slots:
    virtual void addBuilding();
    virtual void removeBuilding();
    virtual void buildingChanged(int);
    virtual void buildingEquipments();
    virtual void sortBuildings();
    virtual void modifyBuilding();
    virtual void filterChanged();

protected slots:
    virtual void languageChange();

};

#endif // BUILDINGSFORM_TEMPLATE_H
