#ifndef SUBJECTSFORM_TEMPLATE_H
#define SUBJECTSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_SubjectsForm_template
{
public:
    QGridLayout *gridLayout;
    QPushButton *removeSubjectPushButton;
    QPushButton *addSubjectPushButton;
    QPushButton *renameSubjectPushButton;
    QPushButton *sortSubjectsPushButton;
    Q3ListBox *subjectsListBox;
    Q3TextEdit *currentSubjectTextEdit;
    QPushButton *closePushButton;
    QPushButton *activateSubjectPushButton;
    QPushButton *deactivateSubjectPushButton;

    void setupUi(QDialog *SubjectsForm_template)
    {
        if (SubjectsForm_template->objectName().isEmpty())
            SubjectsForm_template->setObjectName(QString::fromUtf8("SubjectsForm_template"));
        SubjectsForm_template->resize(652, 554);
        gridLayout = new QGridLayout(SubjectsForm_template);
        gridLayout->setSpacing(6);
        gridLayout->setMargin(11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        removeSubjectPushButton = new QPushButton(SubjectsForm_template);
        removeSubjectPushButton->setObjectName(QString::fromUtf8("removeSubjectPushButton"));

        gridLayout->addWidget(removeSubjectPushButton, 1, 1, 1, 1);

        addSubjectPushButton = new QPushButton(SubjectsForm_template);
        addSubjectPushButton->setObjectName(QString::fromUtf8("addSubjectPushButton"));

        gridLayout->addWidget(addSubjectPushButton, 1, 0, 1, 1);

        renameSubjectPushButton = new QPushButton(SubjectsForm_template);
        renameSubjectPushButton->setObjectName(QString::fromUtf8("renameSubjectPushButton"));

        gridLayout->addWidget(renameSubjectPushButton, 2, 0, 1, 1);

        sortSubjectsPushButton = new QPushButton(SubjectsForm_template);
        sortSubjectsPushButton->setObjectName(QString::fromUtf8("sortSubjectsPushButton"));

        gridLayout->addWidget(sortSubjectsPushButton, 2, 1, 1, 1);

        subjectsListBox = new Q3ListBox(SubjectsForm_template);
        subjectsListBox->setObjectName(QString::fromUtf8("subjectsListBox"));

        gridLayout->addWidget(subjectsListBox, 0, 0, 1, 1);

        currentSubjectTextEdit = new Q3TextEdit(SubjectsForm_template);
        currentSubjectTextEdit->setObjectName(QString::fromUtf8("currentSubjectTextEdit"));
        currentSubjectTextEdit->setReadOnly(true);

        gridLayout->addWidget(currentSubjectTextEdit, 0, 1, 1, 1);

        closePushButton = new QPushButton(SubjectsForm_template);
        closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

        gridLayout->addWidget(closePushButton, 4, 0, 1, 1);

        activateSubjectPushButton = new QPushButton(SubjectsForm_template);
        activateSubjectPushButton->setObjectName(QString::fromUtf8("activateSubjectPushButton"));

        gridLayout->addWidget(activateSubjectPushButton, 3, 0, 1, 1);

        deactivateSubjectPushButton = new QPushButton(SubjectsForm_template);
        deactivateSubjectPushButton->setObjectName(QString::fromUtf8("deactivateSubjectPushButton"));

        gridLayout->addWidget(deactivateSubjectPushButton, 3, 1, 1, 1);

        QWidget::setTabOrder(subjectsListBox, addSubjectPushButton);
        QWidget::setTabOrder(addSubjectPushButton, removeSubjectPushButton);
        QWidget::setTabOrder(removeSubjectPushButton, renameSubjectPushButton);
        QWidget::setTabOrder(renameSubjectPushButton, sortSubjectsPushButton);
        QWidget::setTabOrder(sortSubjectsPushButton, activateSubjectPushButton);
        QWidget::setTabOrder(activateSubjectPushButton, deactivateSubjectPushButton);
        QWidget::setTabOrder(deactivateSubjectPushButton, closePushButton);
        QWidget::setTabOrder(closePushButton, currentSubjectTextEdit);

        retranslateUi(SubjectsForm_template);
        QObject::connect(closePushButton, SIGNAL(clicked()), SubjectsForm_template, SLOT(close()));
        QObject::connect(addSubjectPushButton, SIGNAL(clicked()), SubjectsForm_template, SLOT(addSubject()));
        QObject::connect(removeSubjectPushButton, SIGNAL(clicked()), SubjectsForm_template, SLOT(removeSubject()));
        QObject::connect(renameSubjectPushButton, SIGNAL(clicked()), SubjectsForm_template, SLOT(renameSubject()));
        QObject::connect(sortSubjectsPushButton, SIGNAL(clicked()), SubjectsForm_template, SLOT(sortSubjects()));
        QObject::connect(subjectsListBox, SIGNAL(highlighted(int)), SubjectsForm_template, SLOT(subjectChanged(int)));
        QObject::connect(activateSubjectPushButton, SIGNAL(clicked()), SubjectsForm_template, SLOT(activateSubject()));
        QObject::connect(deactivateSubjectPushButton, SIGNAL(clicked()), SubjectsForm_template, SLOT(deactivateSubject()));
        QObject::connect(subjectsListBox, SIGNAL(selected(QString)), SubjectsForm_template, SLOT(renameSubject()));

        QMetaObject::connectSlotsByName(SubjectsForm_template);
    } // setupUi

    void retranslateUi(QDialog *SubjectsForm_template)
    {
        SubjectsForm_template->setWindowTitle(QApplication::translate("SubjectsForm_template", "FET - subjects", 0, QApplication::UnicodeUTF8));
        removeSubjectPushButton->setText(QApplication::translate("SubjectsForm_template", "Remove current", 0, QApplication::UnicodeUTF8));
        addSubjectPushButton->setText(QApplication::translate("SubjectsForm_template", "Add subject", 0, QApplication::UnicodeUTF8));
        renameSubjectPushButton->setText(QApplication::translate("SubjectsForm_template", "Rename current", 0, QApplication::UnicodeUTF8));
        sortSubjectsPushButton->setText(QApplication::translate("SubjectsForm_template", "Sort alphabetically", 0, QApplication::UnicodeUTF8));
        subjectsListBox->clear();
        subjectsListBox->insertItem(QApplication::translate("SubjectsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        closePushButton->setText(QApplication::translate("SubjectsForm_template", "Close", 0, QApplication::UnicodeUTF8));
        activateSubjectPushButton->setText(QApplication::translate("SubjectsForm_template", "Activate all activities for selected subject", 0, QApplication::UnicodeUTF8));
        deactivateSubjectPushButton->setText(QApplication::translate("SubjectsForm_template", "De-activate all activities for selected subject", 0, QApplication::UnicodeUTF8));
        Q_UNUSED(SubjectsForm_template);
    } // retranslateUi

};

namespace Ui {
    class SubjectsForm_template: public Ui_SubjectsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class SubjectsForm_template : public QDialog, public Ui::SubjectsForm_template
{
    Q_OBJECT

public:
    SubjectsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~SubjectsForm_template();

public slots:
    virtual void addSubject();
    virtual void removeSubject();
    virtual void renameSubject();
    virtual void sortSubjects();
    virtual void subjectChanged(int);
    virtual void activateSubject();
    virtual void deactivateSubject();

protected slots:
    virtual void languageChange();

};

#endif // SUBJECTSFORM_TEMPLATE_H
