#ifndef TIMETABLEVIEWSTUDENTSFORM_TEMPLATE_H
#define TIMETABLEVIEWSTUDENTSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3Header>
#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3Table>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_TimetableViewStudentsForm_template
{
public:
    QGridLayout *gridLayout;
    QLabel *yearsTextLabel;
    QLabel *groupsTextLabel;
    QLabel *subgroupsTextLabel;
    Q3ListBox *subgroupsListBox;
    QLabel *classNameTextLabel;
    Q3ListBox *yearsListBox;
    Q3ListBox *groupsListBox;
    Q3Table *studentsTimetableTable;
    QPushButton *lockTimePushButton;
    QPushButton *lockTimeSpacePushButton;
    QPushButton *lockSpacePushButton;
    Q3TextEdit *detailsTextEdit;
    QLabel *detailsTextLabel;
    QPushButton *closePushButton;

    void setupUi(QDialog *TimetableViewStudentsForm_template)
    {
        if (TimetableViewStudentsForm_template->objectName().isEmpty())
            TimetableViewStudentsForm_template->setObjectName(QString::fromUtf8("TimetableViewStudentsForm_template"));
        TimetableViewStudentsForm_template->resize(767, 544);
        gridLayout = new QGridLayout(TimetableViewStudentsForm_template);
        gridLayout->setSpacing(6);
        gridLayout->setMargin(11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        yearsTextLabel = new QLabel(TimetableViewStudentsForm_template);
        yearsTextLabel->setObjectName(QString::fromUtf8("yearsTextLabel"));
        yearsTextLabel->setWordWrap(false);

        gridLayout->addWidget(yearsTextLabel, 0, 0, 1, 1);

        groupsTextLabel = new QLabel(TimetableViewStudentsForm_template);
        groupsTextLabel->setObjectName(QString::fromUtf8("groupsTextLabel"));
        groupsTextLabel->setWordWrap(false);

        gridLayout->addWidget(groupsTextLabel, 0, 1, 1, 1);

        subgroupsTextLabel = new QLabel(TimetableViewStudentsForm_template);
        subgroupsTextLabel->setObjectName(QString::fromUtf8("subgroupsTextLabel"));
        subgroupsTextLabel->setWordWrap(false);

        gridLayout->addWidget(subgroupsTextLabel, 0, 2, 1, 1);

        subgroupsListBox = new Q3ListBox(TimetableViewStudentsForm_template);
        subgroupsListBox->setObjectName(QString::fromUtf8("subgroupsListBox"));

        gridLayout->addWidget(subgroupsListBox, 1, 2, 3, 1);

        classNameTextLabel = new QLabel(TimetableViewStudentsForm_template);
        classNameTextLabel->setObjectName(QString::fromUtf8("classNameTextLabel"));
        classNameTextLabel->setWordWrap(false);

        gridLayout->addWidget(classNameTextLabel, 4, 0, 1, 3);

        yearsListBox = new Q3ListBox(TimetableViewStudentsForm_template);
        yearsListBox->setObjectName(QString::fromUtf8("yearsListBox"));

        gridLayout->addWidget(yearsListBox, 1, 0, 3, 1);

        groupsListBox = new Q3ListBox(TimetableViewStudentsForm_template);
        groupsListBox->setObjectName(QString::fromUtf8("groupsListBox"));

        gridLayout->addWidget(groupsListBox, 1, 1, 3, 1);

        studentsTimetableTable = new Q3Table(TimetableViewStudentsForm_template);
        studentsTimetableTable->setObjectName(QString::fromUtf8("studentsTimetableTable"));
        studentsTimetableTable->setNumRows(12);
        studentsTimetableTable->setNumCols(5);
        studentsTimetableTable->setReadOnly(true);

        gridLayout->addWidget(studentsTimetableTable, 5, 0, 3, 3);

        lockTimePushButton = new QPushButton(TimetableViewStudentsForm_template);
        lockTimePushButton->setObjectName(QString::fromUtf8("lockTimePushButton"));

        gridLayout->addWidget(lockTimePushButton, 0, 3, 2, 1);

        lockTimeSpacePushButton = new QPushButton(TimetableViewStudentsForm_template);
        lockTimeSpacePushButton->setObjectName(QString::fromUtf8("lockTimeSpacePushButton"));

        gridLayout->addWidget(lockTimeSpacePushButton, 3, 3, 2, 1);

        lockSpacePushButton = new QPushButton(TimetableViewStudentsForm_template);
        lockSpacePushButton->setObjectName(QString::fromUtf8("lockSpacePushButton"));

        gridLayout->addWidget(lockSpacePushButton, 2, 3, 1, 1);

        detailsTextEdit = new Q3TextEdit(TimetableViewStudentsForm_template);
        detailsTextEdit->setObjectName(QString::fromUtf8("detailsTextEdit"));
        detailsTextEdit->setReadOnly(true);

        gridLayout->addWidget(detailsTextEdit, 7, 3, 1, 1);

        detailsTextLabel = new QLabel(TimetableViewStudentsForm_template);
        detailsTextLabel->setObjectName(QString::fromUtf8("detailsTextLabel"));
        detailsTextLabel->setWordWrap(false);

        gridLayout->addWidget(detailsTextLabel, 6, 3, 1, 1);

        closePushButton = new QPushButton(TimetableViewStudentsForm_template);
        closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

        gridLayout->addWidget(closePushButton, 5, 3, 1, 1);

        QWidget::setTabOrder(yearsListBox, groupsListBox);
        QWidget::setTabOrder(groupsListBox, subgroupsListBox);
        QWidget::setTabOrder(subgroupsListBox, studentsTimetableTable);
        QWidget::setTabOrder(studentsTimetableTable, lockTimePushButton);
        QWidget::setTabOrder(lockTimePushButton, lockSpacePushButton);
        QWidget::setTabOrder(lockSpacePushButton, lockTimeSpacePushButton);
        QWidget::setTabOrder(lockTimeSpacePushButton, closePushButton);
        QWidget::setTabOrder(closePushButton, detailsTextEdit);

        retranslateUi(TimetableViewStudentsForm_template);
        QObject::connect(yearsListBox, SIGNAL(highlighted(QString)), TimetableViewStudentsForm_template, SLOT(yearChanged(QString)));
        QObject::connect(groupsListBox, SIGNAL(highlighted(QString)), TimetableViewStudentsForm_template, SLOT(groupChanged(QString)));
        QObject::connect(subgroupsListBox, SIGNAL(highlighted(QString)), TimetableViewStudentsForm_template, SLOT(subgroupChanged(QString)));
        QObject::connect(closePushButton, SIGNAL(clicked()), TimetableViewStudentsForm_template, SLOT(close()));
        QObject::connect(studentsTimetableTable, SIGNAL(currentChanged(int,int)), TimetableViewStudentsForm_template, SLOT(detailActivity(int,int)));
        QObject::connect(lockTimePushButton, SIGNAL(clicked()), TimetableViewStudentsForm_template, SLOT(lockTime()));
        QObject::connect(lockSpacePushButton, SIGNAL(clicked()), TimetableViewStudentsForm_template, SLOT(lockSpace()));
        QObject::connect(lockTimeSpacePushButton, SIGNAL(clicked()), TimetableViewStudentsForm_template, SLOT(lockTimeSpace()));

        QMetaObject::connectSlotsByName(TimetableViewStudentsForm_template);
    } // setupUi

    void retranslateUi(QDialog *TimetableViewStudentsForm_template)
    {
        TimetableViewStudentsForm_template->setWindowTitle(QApplication::translate("TimetableViewStudentsForm_template", "Viewing the timetable for the students", 0, QApplication::UnicodeUTF8));
        yearsTextLabel->setText(QApplication::translate("TimetableViewStudentsForm_template", "Year", 0, QApplication::UnicodeUTF8));
        groupsTextLabel->setText(QApplication::translate("TimetableViewStudentsForm_template", "Group", 0, QApplication::UnicodeUTF8));
        subgroupsTextLabel->setText(QApplication::translate("TimetableViewStudentsForm_template", "Subgroup", 0, QApplication::UnicodeUTF8));
        subgroupsListBox->clear();
        subgroupsListBox->insertItem(QApplication::translate("TimetableViewStudentsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        classNameTextLabel->setText(QApplication::translate("TimetableViewStudentsForm_template", "Class name", 0, QApplication::UnicodeUTF8));
        yearsListBox->clear();
        yearsListBox->insertItem(QApplication::translate("TimetableViewStudentsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        groupsListBox->clear();
        groupsListBox->insertItem(QApplication::translate("TimetableViewStudentsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
        lockTimePushButton->setText(QApplication::translate("TimetableViewStudentsForm_template", "Toggle lock/unlock selected\n"
"activities (only time)", 0, QApplication::UnicodeUTF8));
        lockTimeSpacePushButton->setText(QApplication::translate("TimetableViewStudentsForm_template", "Toggle lock/unlock selected\n"
"activities (time and space)", 0, QApplication::UnicodeUTF8));
        lockSpacePushButton->setText(QApplication::translate("TimetableViewStudentsForm_template", "Toggle lock/unlock selected\n"
"activities (only space)", 0, QApplication::UnicodeUTF8));
        detailsTextEdit->setText(QApplication::translate("TimetableViewStudentsForm_template", "Please click on the table for details for a specific activity.", 0, QApplication::UnicodeUTF8));
        detailsTextLabel->setText(QApplication::translate("TimetableViewStudentsForm_template", "Details", 0, QApplication::UnicodeUTF8));
        closePushButton->setText(QApplication::translate("TimetableViewStudentsForm_template", "Close", 0, QApplication::UnicodeUTF8));
        Q_UNUSED(TimetableViewStudentsForm_template);
    } // retranslateUi

};

namespace Ui {
    class TimetableViewStudentsForm_template: public Ui_TimetableViewStudentsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class TimetableViewStudentsForm_template : public QDialog, public Ui::TimetableViewStudentsForm_template
{
    Q_OBJECT

public:
    TimetableViewStudentsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~TimetableViewStudentsForm_template();

public slots:
    virtual void groupChanged(const QString&);
    virtual void detailActivity(int, int);
    virtual void subgroupChanged(const QString&);
    virtual void yearChanged(const QString&);
    virtual void lockTime();
    virtual void lockSpace();
    virtual void lockTimeSpace();

protected slots:
    virtual void languageChange();

};

#endif // TIMETABLEVIEWSTUDENTSFORM_TEMPLATE_H
